package im.creep.bukkitinsider;

import im.creep.bukkitinsider.smartassery.SmartassPluginManager;
import org.bukkit.Server;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.command.SimpleCommandMap;
import org.bukkit.event.Event;
import org.bukkit.plugin.RegisteredListener;
import org.bukkit.plugin.SimplePluginManager;
import org.bukkit.plugin.java.JavaPlugin;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.SortedSet;
import java.util.logging.Logger;

/**
 * some day I will put some licence text here, but not now. //apiocera
 */
public class BukkitInsiderPlugin extends JavaPlugin {
	private boolean failure;
	SmartassPluginManager smartManager;

	public void onEnable() {
		failure = true;
		try {
			initIntrospect();
		} catch (NoSuchMethodException e) {
			Logger.getLogger("Minecraft").severe("BukkitInsider weirdly could not be loaded: could not find " + e.getMessage() + " method. Are you sure you are using CraftBukkit?");
			e.printStackTrace();
			return;
		} catch (ClassNotFoundException e) {
			Logger.getLogger("Minecraft").severe("BukkitInsider could not be loaded: could not find  " + e.getMessage() + " class. Are you sure you are using CraftBukkit?");
			e.printStackTrace();
			return;
		} catch (NoSuchFieldException e) {
			Logger.getLogger("Minecraft").severe("BukkitInsider could not be loaded: could not find  " + e.getMessage() + " field. Are you sure you are using CraftBukkit?");
			e.printStackTrace();
			return;
		} catch (IllegalAccessException e) {
			Logger.getLogger("Minecraft").severe("BukkitInsider could not be loaded: could not use  " + e.getMessage() + " field. Are you sure you are using CraftBukkit?");
			e.printStackTrace();
			return;
		}

		Logger.getLogger("Minecraft").info("BukkitInsider loaded. Use /introspect to get some info.");
		failure = false;
	}

	public void onDisable() {
	}

	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args) {
		if (!failure) {
			if (cmd.getName().equalsIgnoreCase("introspect") && sender.isOp()) {
				introspect();
				return true;
			}
		}
		return false;
	}

	// Note here: this is dangerous code. Don't try this at home.
	// Lots of mind-boggling Java reflections, but after this I can use every awesome thing from PluginManager.
	// This method substitutes Bukkit's own PluginManager with mine.
	// It is an exact copy, but has all fields public, effectively allowing to intercept any event.
	// But! it has to be called prior to all other plugin loads. Probably. I'm not sure.
	private synchronized void initIntrospect() throws NoSuchMethodException, ClassNotFoundException, NoSuchFieldException, IllegalAccessException {
		Logger.getLogger("Minecraft").info("[BukkitInsider] Injecting reflection...");
		Server server = this.getServer();

		// to make an exact copy of PM, I need to construct it with the same parameters the original has got now.
		// commandMap is needed in the constructor, so I'm taking it right away.
		SimplePluginManager simplePluginManager = (SimplePluginManager) server.getPluginManager();
		Field cM = SimplePluginManager.class.getDeclaredField("commandMap");
		cM.setAccessible(true);
		smartManager = new SmartassPluginManager(server, (SimpleCommandMap) cM.get(simplePluginManager));

		// and now for other fields.
		for (Field f : simplePluginManager.getClass().getDeclaredFields()) {
			f.setAccessible(true);
			smartManager.getClass().getField(f.getName()).set(smartManager, f.get(simplePluginManager));
		}

		// on to substituting. I unset private and final modifiers of the original pluginManager field in CraftServer here,..
		Field plugManager = server.getClass().getDeclaredField("pluginManager");
		plugManager.setAccessible(true);
		Field modifiersField = Field.class.getDeclaredField("modifiers");
		modifiersField.setAccessible(true);
		modifiersField.setInt(plugManager, plugManager.getModifiers() & ~Modifier.FINAL);

		// ..and make a quick swap here. hope no one noticed!
		plugManager.set(server, smartManager);

		// yup.
		Logger.getLogger("Minecraft").info("[BukkitInsider] Reflection OK, now able to intercept.");
	}

	private void introspect() {
		Logger.getLogger("Minecraft").info("------- Starting introspection");
		Logger.getLogger("Minecraft").info("[-] Event subscriptions");
		for (Event.Type ev : Event.Type.values()) {
			SortedSet<RegisteredListener> registeredListeners = smartManager.getEventListeners(ev);
			if (!registeredListeners.isEmpty()) {
				Long calls = smartManager.getEventCalls(ev);
				if (calls != 0){
					Logger.getLogger("Minecraft").info("    [-] " + ev.toString() + " (invoked " + smartManager.getEventCalls(ev) + " times, avg " + smartManager.getTimeRunning(ev)/smartManager.getEventCalls(ev) + "ms to process)");
				} else {
					Logger.getLogger("Minecraft").info("    [-] " + ev.toString() + " (never invoked)");
				}
				for (RegisteredListener rl : registeredListeners) {
					Logger.getLogger("Minecraft").info("        [-] " + rl.getListener().getClass().getName() + " [" + rl.getPlugin().getDescription().getName() + "]");
				}
			}
		}


	}
}
