package im.creep.bukkitinsider.smartassery;

import org.bukkit.Server;
import org.bukkit.command.SimpleCommandMap;
import org.bukkit.event.Event;
import org.bukkit.plugin.AuthorNagException;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.PluginManager;
import org.bukkit.plugin.RegisteredListener;

import java.util.HashMap;
import java.util.SortedSet;
import java.util.logging.Level;

/**
 * some day I will put some licence text here, but not now. //apiocera
 */
public class SmartassPluginManager extends ModifiableSimplePluginManager implements PluginManager {
	private HashMap<Event.Type, Long> runs = new HashMap<Event.Type, Long>();
	private HashMap<Event.Type, Long> timeRunning = new HashMap<Event.Type, Long>();

	public SmartassPluginManager(Server instance, SimpleCommandMap commandMap) {
		super(instance, commandMap);
		for (Event.Type et: Event.Type.values()){
			runs.put(et, new Long(0));
			timeRunning.put(et, new Long(0));
		}
	}

	public Long getEventCalls(Event.Type type){
		return runs.get(type);
	}

	public Long getTimeRunning(Event.Type type){
		return timeRunning.get(type);
	}


	public synchronized void callEvent(Event event) {
		SortedSet<RegisteredListener> eventListeners = listeners.get(event.getType());
		Long ctime = System.currentTimeMillis();

		Long called = runs.get(event.getType());
		called++;
		runs.put(event.getType(), called);

		if (eventListeners != null) {
			for (RegisteredListener registration : eventListeners) {
				try {
					registration.callEvent(event);
				} catch (AuthorNagException ex) {
					Plugin plugin = registration.getPlugin();

					if (plugin.isNaggable()) {
						plugin.setNaggable(false);

						String author = "<NoAuthorGiven>";

						if (plugin.getDescription().getAuthors().size() > 0) {
							author = plugin.getDescription().getAuthors().get(0);
						}
						server.getLogger().log(Level.SEVERE, String.format(
							"Nag author: '%s' of '%s' about the following: %s",
							author,
							plugin.getDescription().getName(),
							ex.getMessage()
						));
					}
				} catch (Throwable ex) {
					server.getLogger().log(Level.SEVERE, "Could not pass event " + event.getType() + " to " + registration.getPlugin().getDescription().getName(), ex);
				}
			}
		}

		Long now_ttime = timeRunning.get(event.getType());
		now_ttime += (System.currentTimeMillis() - ctime);
		timeRunning.put(event.getType(), now_ttime);
	}
}
